import { PostRPCClient, ContentSizer, Dimensions } from './external.types';
import { ZengineField, ZengineContextData, ZengineFilter, ZengineFiltersPanelOptions, ZengineHTTPResponse, ZenginePluginDataCallOptions, ZengineAPIRequestOptions, ZengineDropdownOptions } from './zengine.types';
export declare const rpcClient: PostRPCClient;
export declare function znContext(): Promise<ZengineContextData>;
export declare function znContext(callback: (err: Error, context: ZengineContextData) => void): null;
export declare function znConfirm(message: string): Promise<boolean>;
export declare function znConfirm(message: string, callback: (err: Error, confirmed: boolean) => void): null;
export declare function znMessage(message: string, type?: 'info' | 'saved' | 'warning' | 'error', duration?: number): Promise<undefined>;
export declare function znFiltersPanel(options: ZengineFiltersPanelOptions): Promise<ZengineFilter>;
export declare function znFiltersPanel(options: ZengineFiltersPanelOptions, callback: (err: Error, filter: ZengineFilter) => void): null;
export declare function znResize(dimensions: Dimensions): Promise<Dimensions>;
export declare const znSizer: ContentSizer;
export declare function autoSize(): void;
export declare function stopAutoSizing(): void;
export declare function znHttp<T = any>(request: ZengineAPIRequestOptions): Promise<ZengineHTTPResponse<T>>;
export declare function znHttp<T = any>(request: ZengineAPIRequestOptions, callback: (err: Error, resp: ZengineHTTPResponse<T>) => void): null;
export declare function znFetch(url: string, init?: Request): Promise<Response>;
export declare function znFetch(init: Request): Promise<Response>;
export declare function znPluginData<T = any>(options: ZenginePluginDataCallOptions, callback: (err: Error, resp: ZengineHTTPResponse<T>) => void): null;
export declare function znPluginData<T = any>(options: ZenginePluginDataCallOptions): Promise<ZengineHTTPResponse<T>>;
export declare function znOpenDropdown(options: ZengineDropdownOptions): Promise<any>;
export declare const znLocation: {
    protocol: () => Promise<any>;
    host: () => Promise<any>;
    port: () => Promise<any>;
    pathParams: () => Promise<any>;
    pathname: () => Promise<any>;
    reload: () => Promise<any>;
    hash: (hash?: string | undefined) => Promise<any>;
    href: (href?: string | undefined) => Promise<any>;
    searchParams: (query?: string | undefined, value?: string | number | undefined) => Promise<any>;
    navigate: (path: string) => Promise<any>;
};
export declare const znNumericValue: (amount: number, field: ZengineField) => string;
export declare const znRefreshToken: () => Promise<void>;
//# sourceMappingURL=index.d.ts.map